Attribute VB_Name = "modUtils"
Option Explicit
Private Const FILE_BEGIN = 0
Private Const FILE_END = 2
Private Const FILE_SHARE_READ = &H1
Private Const FILE_SHARE_WRITE = &H2
Private Const CREATE_NEW = 1
Private Const OPEN_EXISTING = 3
Private Const GENERIC_READ = &H80000000
Private Const GENERIC_WRITE = &H40000000
Private Const CREATE_ALWAYS = 2
Private Const INVALID_HANDLE_VALUE = -1

Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Const SW_SHOWNORMAL = 1

Private Declare Function WriteFile Lib "Kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Any) As Long
Private Declare Function ReadFile Lib "Kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Any) As Long
Private Declare Function CreateFile Lib "Kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Any, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function CloseHandle Lib "Kernel32" (ByVal hObject As Long) As Long
Private Declare Function SetFilePointer Lib "Kernel32" (ByVal hFile As Long, ByVal lDistanceToMove As Long, lpDistanceToMoveHigh As Long, ByVal dwMoveMethod As Long) As Long

Public AppName As String
Public AppCreatedBy As String
Public LinkCaption As String
Public LinkURL As String

Public Sub LoadSettingsFromINI(Filename As String)
Dim s As String
s = App.Path
s = s & IIf(Right$(s, 1) = "\", "", "\")
INIFile = s & Filename
s = ""
ReadStringSetting "Configuration", "Name", s: s = Trim$(s): If Len(s) <> 0 Then AppName = s: s = ""
ReadStringSetting "Configuration", "Creator", s: s = Trim$(s): If Len(s) <> 0 Then AppCreatedBy = s: s = ""
ReadStringSetting "Configuration", "URLCaption", s: s = Trim$(s): If Len(s) <> 0 Then LinkCaption = s: s = ""
ReadStringSetting "Configuration", "URL", s: s = Trim$(s): If Len(s) <> 0 Then LinkURL = s: s = ""
If Len(AppName) <> 0 Then frmMain.Caption = AppName
End Sub

Public Sub NewTemplate()
With frmMain

'frame 0
.txtSoftwareName.text = ""
.txtSoftwareBy = ""
.txtSoftwareDescription.text = ""
.txtAboutLink.text = ""
.txtAboutURL.text = ""

'frame 1

.txtRecipe.text = _
"  This is an example of a software recipe." & vbCrLf & _
"" & vbCrLf & _
"  Your recipe should contain at least one tag." & vbCrLf & _
"" & vbCrLf & _
"  These tags, shown as [#RecipeTag#], represent variable text in your recipe." & vbCrLf & _
"" & vbCrLf & _
"  In the final document created by the users, the tags will be replaced by" & vbCrLf & _
" the answers to your questions, specified later in this wizard." & vbCrLf & _
"" & vbCrLf & _
"  The tags can have almost any text in them, as long as they start with [ ," & vbCrLf & _
" followed by # and end with #, followed by ]" & vbCrLf & _
"" & vbCrLf & _
"  For example, [#DemoTag#] is also a valid tag."


'frame 2
.lstTags.Clear

'frame 3

.txtTagDescription.text = ""
.txtTagQuestion.text = ""
.chkTagMultiline.Value = vbUnchecked
.chkTagOptional.Value = vbUnchecked
.lblTags.Caption = "Current tag : "

'frame 4
.chkClipboard.Value = vbUnchecked
.chkSaveHTML.Value = vbUnchecked
.chkPrint.Value = vbUnchecked
.chkSaveTXT.Value = vbUnchecked

' frame 5

.txtResH.text = "640"
.txtResV.text = "480"
.chkAfter.Value = vbUnchecked
.chkBefore.Value = vbUnchecked
.txtBefore.text = ""
.txtAfter.text = ""
.txtFolder.text = "C:\"

End With

End Sub

Public Sub SaveTemplate(Filename As String)
Dim Buffer() As Byte
Dim BufferSize As Long
Dim s As String
Dim handle As Long
Dim bWrote As Long
Dim i As Long
s = GenerateSettingsString()
handle = CreateFile(Filename, GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, CREATE_ALWAYS, 0, 0)
If handle = INVALID_HANDLE_VALUE Then
   MsgBox "There was an error saving the file. Please try again.", vbOKOnly Or vbCritical, "Error saving file"
   Exit Sub
End If
ReDim Buffer(1 To 8)
Buffer(1) = Asc("T")
Buffer(2) = Asc("E")
Buffer(3) = Asc("M")
Buffer(4) = Asc("P")
Buffer(5) = Asc("L")
Buffer(6) = Asc("A")
Buffer(7) = Asc("T")
Buffer(8) = Asc("E")
WriteFile handle, Buffer(1), 8, bWrote, ByVal 0&
BufferSize = Len(s)
ReDim Buffer(1 To BufferSize)
For i = 1 To BufferSize
 Buffer(i) = Asc(Mid$(s, i, 1))
Next i
WriteFile handle, BufferSize, Len(BufferSize), bWrote, ByVal 0&
WriteFile handle, Buffer(1), BufferSize, bWrote, ByVal 0&
CloseHandle handle
End Sub

Public Sub SaveExecutable(Filename As String)
Dim Buffer() As Byte
Dim BufferSize As Long
Dim s As String
Dim handle As Long
Dim bWrote As Long
Dim i As Long
s = GenerateSettingsString()
handle = CreateFile(Filename, GENERIC_WRITE, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, CREATE_ALWAYS, 0, 0)
If handle = INVALID_HANDLE_VALUE Then
   MsgBox "There was an error saving the file. Please try again.", vbOKOnly Or vbCritical, "Error saving file"
   Exit Sub
End If
BufferSize = Len(s)
ReDim Buffer(1 To BufferSize)
For i = 1 To BufferSize
 Buffer(i) = Asc(Mid$(s, i, 1))
Next i
WriteFile handle, SFXBuffer(1), SFXBufferLen, bWrote, ByVal 0&
WriteFile handle, Buffer(1), BufferSize, bWrote, ByVal 0&
WriteFile handle, BufferSize, Len(BufferSize), bWrote, ByVal 0&
CloseHandle handle
End Sub
Public Sub OpenTemplate(Filename As String)
Dim Buffer() As Byte
Dim BufferSize As Long
Dim s As String
Dim handle As Long
Dim Values() As String
Dim bread As Long
Dim i As Long
Dim k As Long
s = ""
handle = CreateFile(Filename, GENERIC_READ, FILE_SHARE_READ Or FILE_SHARE_WRITE, ByVal 0&, OPEN_EXISTING, 0, 0)
If handle = INVALID_HANDLE_VALUE Then
   MsgBox "There was an error opening the file. Please try again or close other programs that may access it.", vbOKOnly Or vbCritical, "Error opening file"
   Exit Sub
End If
ReDim Buffer(1 To 8)
ReadFile handle, Buffer(1), 8, bread, ByVal 0&
If bread <> 8 Then
  MsgBox "This template is not in the valid file format or corrupted.", vbOKOnly Or vbCritical, "Error opening file"
  CloseHandle handle
  Exit Sub
End If
s = Chr(Buffer(1)) & Chr(Buffer(2)) & Chr(Buffer(3)) & Chr(Buffer(4)) & Chr(Buffer(5)) & Chr(Buffer(6)) & Chr(Buffer(7)) & Chr(Buffer(8))
If s <> "TEMPLATE" Then
   CloseHandle handle
   MsgBox "This is not a valid template file or it is corrupted.", vbOKOnly Or vbCritical, "Not a valid template"
   Exit Sub
End If
ReadFile handle, BufferSize, Len(BufferSize), bread, ByVal 0&
If bread <> 4 Then
   CloseHandle handle
   MsgBox "This is not a valid template file or it is corrupted.", vbOKOnly Or vbCritical, "Not a valid template"
   Exit Sub
End If
If BufferSize > 1048576 Then BufferSize = 1048576 'just a safety precaution
ReDim Buffer(1 To BufferSize)
   
ReadFile handle, Buffer(1), BufferSize, bread, ByVal 0&
If BufferSize <> bread Then
   CloseHandle handle
   MsgBox "This is not a valid template file or it is corrupted.", vbOKOnly Or vbCritical, "Not a valid template"
   Exit Sub
End If
s = ""

For i = 1 To BufferSize
 s = s & Chr(Buffer(i))
Next i

CloseHandle handle
Values() = Split(s, Chr(1))

With frmMain

'frame 0
k = 0
.txtSoftwareName.text = Values(k): k = k + 1
.txtSoftwareBy.text = Values(k): k = k + 1
.txtSoftwareDescription.text = Values(k): k = k + 1
.txtAboutLink.text = Values(k): k = k + 1
.txtAboutURL.text = Values(k): k = k + 1

'frame 1

.txtRecipe.text = Values(k): k = k + 1
'frame 2
TagsNr = CLng(Trim$(Values(k))): k = k + 1
TagsNrMax = TagsNr
If TagsNr = 0 Then TagsNrMax = 1
ReDim Preserve Tags(1 To TagsNrMax)


'frame 3
If TagsNr > 0 Then
  For i = 1 To TagsNr
    Tags(i).Tag = Values(k): k = k + 1
    Tags(i).Question = Values(k): k = k + 1
    Tags(i).Description = Values(k): k = k + 1
    Tags(i).isOptional = IIf(Trim$(Values(k)) = "1", True, False): k = k + 1
    Tags(i).isMultiLine = IIf(Trim$(Values(k)) = "1", True, False): k = k + 1
  Next i
End If

'frame 4

.chkSaveHTML.Value = IIf(Trim$(Values(k)) = "1", vbChecked, vbUnchecked): k = k + 1
.chkPrint.Value = IIf(Trim$(Values(k)) = "1", vbChecked, vbUnchecked): k = k + 1
.chkSaveTXT.Value = IIf(Trim$(Values(k)) = "1", vbChecked, vbUnchecked): k = k + 1
.chkClipboard.Value = IIf(Trim$(Values(k)) = "1", vbChecked, vbUnchecked): k = k + 1

' frame 5

.txtResH.text = Values(k): k = k + 1
.txtResV.text = Values(k): k = k + 1
.chkBefore.Value = IIf(Trim$(Values(k)) = "1", vbChecked, vbUnchecked): k = k + 1
.chkAfter.Value = IIf(Trim$(Values(k)) = "1", vbChecked, vbUnchecked): k = k + 1
.txtBefore.text = Values(k): k = k + 1
.txtAfter.text = Values(k): k = k + 1

End With

End Sub

Private Function GenerateSettingsString() As String
Dim s As String
Dim i As Long
s = ""

With frmMain

'frame 0
s = .txtSoftwareName.text
s = s & Chr(1) & .txtSoftwareBy.text
s = s & Chr(1) & .txtSoftwareDescription.text
s = s & Chr(1) & .txtAboutLink.text
s = s & Chr(1) & .txtAboutURL.text

'frame 1

s = s & Chr(1) & .txtRecipe.text
'frame 2
s = s & Chr(1) & Trim$(CStr(TagsNr))


'frame 3
If TagsNr > 0 Then
  For i = 1 To TagsNr
    s = s & Chr(1) & Tags(i).Tag
    s = s & Chr(1) & Tags(i).Question
    s = s & Chr(1) & Tags(i).Description
    s = s & Chr(1) & IIf(Tags(i).isOptional = True, "1", "0")
    s = s & Chr(1) & IIf(Tags(i).isMultiLine = True, "1", "0")
  Next i
End If

'frame 4

s = s & Chr(1) & IIf(.chkSaveHTML.Value = vbChecked, "1", "0")
s = s & Chr(1) & IIf(.chkPrint.Value = vbChecked, "1", "0")
s = s & Chr(1) & IIf(.chkSaveTXT.Value = vbChecked, "1", "0")
s = s & Chr(1) & IIf(.chkClipboard.Value = vbChecked, "1", "0")


' frame 5

s = s & Chr(1) & .txtResH.text
s = s & Chr(1) & .txtResV.text
s = s & Chr(1) & IIf(.chkBefore.Value = vbChecked, "1", "0")
s = s & Chr(1) & IIf(.chkAfter.Value = vbChecked, "1", "0")
s = s & Chr(1) & .txtBefore.text
s = s & Chr(1) & .txtAfter.text
End With
GenerateSettingsString = s
End Function
